void swap(int* a, int* b);

/*@ requires \valid(a);
    requires \valid(b);
    requires \valid(c);
    requires \separated(a,b,c);
    assigns *a, *b, *c;
    ensures  \at(*a,Pre) == *b;
    ensures  \at(*b,Pre) == *c;
    ensures  \at(*c,Pre) == *a;
*/
void permut(int* a, int *b, int* c) {
  swap(a,b);
  /*@ assert \at(*a,Pre) == *b && \at(*b, Pre) == *a; */
  /*@ assert \at(*c,Pre) == *c; */
  swap(a,c);
}

/*@ requires \valid(a) && \valid(b);
    assigns *a \from *b;
    assigns *b \from *a;
    ensures \old(*a) == *b && \old(*b) == *a;
*/
void swap(int* a, int *b);

/*
Local Variables:
compile-command: "frama-c-gui -wp -wp-rte compose_swap.c"
End:
*/
